import { DatabaseEngine } from "../database-engine";
import * as pg from "pg";
import { DatabaseType, KeyedDatabaseResult } from "../base-model";
import SQLGrammarCompiler from "../query/compiler";
export default class PostgresEngine implements DatabaseEngine {
    private pool;
    constructor(pool: pg.Pool);
    query(sql: string, params: DatabaseType[]): Promise<void>;
    get(sql: string, params: DatabaseType[]): Promise<KeyedDatabaseResult[]>;
    insertAndGetId(table: string, sql: string, params: DatabaseType[]): Promise<number>;
    getGrammarCompiler(): SQLGrammarCompiler;
    /**
     * Converts ? placeholders into numbered $# placeholders that postgres understands.
     */
    private transformQuery(sql, params);
}
