"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const compiler_1 = require("../query/compiler");
class Sqlite3Engine {
    constructor(connection) {
        this.connection = connection;
    }
    query(sql, params) {
        return new Promise((resolve, reject) => {
            this.connection.run(sql, params, err => {
                err ? reject(err) : resolve();
            });
        });
    }
    get(sql, params) {
        return new Promise((resolve, reject) => {
            this.connection.all(sql, params, (err, row) => {
                err ? reject(err) : resolve(row);
            });
        });
    }
    insertAndGetId(table, sql, params) {
        return new Promise((resolve, reject) => {
            this.connection.serialize(() => __awaiter(this, void 0, void 0, function* () {
                yield this.query(sql, params);
                this.get("SELECT last_insert_rowid() AS id FROM " + table, []).then(x => x[0]["id"]).then(resolve, reject);
            }));
        });
    }
    getGrammarCompiler() {
        return new compiler_1.default();
    }
}
exports.default = Sqlite3Engine;
