import QueryBuilder from "./builder";
import { DatabaseType } from "../base-model";
export declare type Operator = "=" | "<" | ">" | "<=" | ">=" | "<>" | "!=" | "<=>" | "LIKE" | "LIKE BINARY" | "NOT LIKE" | "BETWEEN" | "ILIKE" | "&" | "|" | "^" | "<<" | ">>" | "RLIKE" | "REGEXP" | "NOT REGEXP" | "~" | "~*" | "!~" | "!~*" | "SIMILAR TO" | "NOT SIMILAR TO" | "NOT ILIKE" | "~~*" | "!~~*";
export declare type JoinType = "INNER" | "LEFT" | "RIGHT";
export declare type QueryBoolean = "AND" | "OR";
export declare type OrderDirection = "DESC" | "ASC";
export interface SimpleWhereClause {
    type: "basic";
    column: string;
    operator: Operator;
    value: DatabaseType;
    boolean: QueryBoolean;
}
export interface ColumnWhereClause {
    type: "column";
    first: string;
    operator: Operator;
    second: string;
    boolean: QueryBoolean;
}
export interface RawWhereClause {
    type: "raw";
    sql: string;
    values: DatabaseType[];
    boolean: QueryBoolean;
}
export interface NullWhereClause {
    type: "null";
    negate: boolean;
    column: string;
    boolean: QueryBoolean;
}
export interface NestedWhereClause {
    type: "nested";
    builder: QueryBuilder<any>;
    boolean: QueryBoolean;
}
export declare type WhereQueryClause = SimpleWhereClause | ColumnWhereClause | RawWhereClause | NullWhereClause | NestedWhereClause;
