"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require("./");
const base_model_1 = require("./base-model");
class _User extends base_model_1.default {
    constructor() {
        super(...arguments);
        this.phones = this.hasMany(Phone);
    }
}
const User = _1.default.wrap()(_User);
class _Phone extends base_model_1.default {
    constructor() {
        super(...arguments);
        this.user = this.belongsTo(User);
    }
}
const Phone = _1.default.wrap()(_Phone);
const compiler_1 = require("./query/compiler");
(() => __awaiter(this, void 0, void 0, function* () {
    let db;
    console.log(new compiler_1.default().compileSelect(User.where("age", ">", 20).orWhere(nested => {
        nested.where("name", "LIKE", "%a%");
        nested.orWhere("name", "LIKE", "%A%");
    }).limit(10).orderByDesc("age")));
    const user = new User();
    const longPhones = user.phones.select("LEN(number) as number_length").where("number_length", ">=", 10);
    console.log(new compiler_1.default().compileSelect(longPhones));
}))();
