"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_typescript_1 = require("mocha-typescript");
const chai_1 = require("chai");
const builder_1 = require("../query/builder");
let QueryBuilderTests = class QueryBuilderTests {
    throwsOnInvalidLimit() {
        chai_1.expect(() => {
            builder_1.default.table("test").limit(-1);
        }).to.throw("limit() expects a positive integer");
        chai_1.expect(() => {
            builder_1.default.table("test").limit(0);
        }).to.throw("limit() expects a positive integer");
    }
    throwsOnUnsetEngine() {
        chai_1.expect(() => {
            builder_1.default.table("test").get();
        }).to.throw("No database engine has been configured. Ensure that you use Basie.use(engine) before attempting any queries.");
    }
};
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], QueryBuilderTests.prototype, "throwsOnInvalidLimit", null);
__decorate([
    mocha_typescript_1.test,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], QueryBuilderTests.prototype, "throwsOnUnsetEngine", null);
QueryBuilderTests = __decorate([
    mocha_typescript_1.suite
], QueryBuilderTests);
