/**
 * Returns the pluralized table name for the specified string.
 * This trims an optional leading space, then converts the PascalCase
 * to pascal_case and pluralizes it. Converts _LeaderboardCategory into
 * leaderboard_categories for example.
 */
export declare function getTableName(name: string): string;
/**
 * Returns the automatic foreign key name for the specified string.
 * This trims an optional leading space, then converts the PascalCase
 * to pascal_case and appends _id. Converts _LeaderboardCategory into
 * leaderboard_category_id for example.
 */
export declare function getForeignKey(name: string): string;
/**
 * Returns the table name for a pivot table between the two specified tables.
 * This takes the table names of the specified models, then sorts them alphabetically
 * and joins them with an underscore.
 */
export declare function getPivotTableName(a: string, b: string): string;
